Imports System
Imports System.Collections
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.SessionState
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.IO

Namespace ReplaceHtmlVB
	Public Class WebForm1
		Inherits System.Web.UI.Page

#Region "Private members"
		Private searchPatterns As String() = {"*.asp", "*.htm", "*.html"}
		Private Const directoryToSearch As String = "."
#End Region

#Region "Child controls"
		Protected ddlAvailableFiles As DropDownList
		Protected WithEvents btnLoad As Button
		Protected WithEvents btnSave As Button
		Protected txtNewFileName As TextBox
		Protected txtFromTag As TextBox
		Protected txtToTag As TextBox
		Protected editorMain As Telerik.WebControls.RadEditor
#End Region


#Region " Web Form Designer Generated Code "

		'This call is required by the Web Form Designer.
		<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

		End Sub

		Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
			'CODEGEN: This method call is required by the Web Form Designer
			'Do not modify it using the code editor.
			InitializeComponent()
		End Sub

#End Region

		Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
			If Not Page.IsPostBack Then
				InitFiles()
			End If
		End Sub

		'/ <summary>
		'/ Reads the files from the directory to search and fills the dropdownlist
		'/ with the matching file names
		'/ </summary>
		Private Sub InitFiles()
			ddlAvailableFiles.Items.Clear()
			Dim j As Integer
			For j = 0 To searchPatterns.Length - 1
				Dim files As String() = Directory.GetFiles(Server.MapPath(directoryToSearch), searchPatterns(j))
				Dim i As Integer
				For i = 0 To files.Length - 1
					If "*" + Path.GetExtension(files(i)) = searchPatterns(j) Then
						ddlAvailableFiles.Items.Add(New ListItem(files(i)))
					End If
				Next i
			Next j
		End Sub	   'InitFiles

		'/ <summary>
		'/ Loads the text from the selected file between the specified start tag and end tag to the editor
		'/ </summary>
		'/ <param name="sender"></param>
		'/ <param name="e"></param>
		Private Sub btnLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnLoad.Click
			If ddlAvailableFiles.SelectedIndex < 0 Then
				'TODO: some error message displaying can be added here
				Return
			End If
			If Not File.Exists(ddlAvailableFiles.SelectedItem.Value) Then
				'TODO: some error message displaying can be added here
				Return
			End If
			Dim wholeFile As String = ""
			Try
				'read the whole file
				Dim sr As StreamReader = File.OpenText(ddlAvailableFiles.SelectedItem.Value)
				wholeFile = sr.ReadToEnd()
				sr.Close()
			Catch ex As Exception
				Response.Write(("The following error occured: " + ex.Message))
				Return
			End Try

			'get the text before that to edit and the text after it
			Dim startIndex As Integer = wholeFile.LastIndexOf(txtFromTag.Text) + txtFromTag.Text.Length
			Dim endIndex As Integer = wholeFile.IndexOf(txtToTag.Text)
			If startIndex > 0 AndAlso startIndex < wholeFile.Length Then
				ViewState("CurrentHeader") = wholeFile.Substring(0, startIndex)
			Else
				ViewState("CurrentHeader") = ""
			End If
			If endIndex - startIndex > 0 AndAlso endIndex - startIndex < wholeFile.Length - startIndex Then
				ViewState("CurrentFooter") = wholeFile.Substring(endIndex)
			Else
				ViewState("CurrentFooter") = ""
			End If
			If endIndex > 0 AndAlso endIndex < wholeFile.Length Then
				ViewState("CurrentFooter") = wholeFile.Substring(endIndex)
			Else
				ViewState("CurrentFooter") = ""
			End If
			'assign the text to edit to the editor
			If startIndex > 0 AndAlso endIndex - startIndex > 0 AndAlso endIndex - startIndex < wholeFile.Length - startIndex Then
				editorMain.Html = wholeFile.Substring(startIndex, endIndex - startIndex)
			End If
			'set the filename to save to the textbox for convenience
			txtNewFileName.Text = Path.GetFileName(ddlAvailableFiles.SelectedItem.Value)
		End Sub	   'btnLoad_Click



		'/ <summary>
		'/ Saves the content of the editor together with the header and footer,
		'/ stored in the ViewState to the new filename specified
		'/ </summary>
		'/ <param name="sender"></param>
		'/ <param name="e"></param>
		Private Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
			If txtNewFileName.Text = "" Then
				'TODO: add here an error reporting routine
				Return
			End If
			Dim header As String = ""
			Dim footer As String = ""
			If Not (ViewState("CurrentHeader") Is Nothing) Then
				header = ViewState("CurrentHeader").ToString()
			End If
			If Not (ViewState("CurrentFooter") Is Nothing) Then
				footer = ViewState("CurrentFooter").ToString()
			End If
			Try
				Dim sw As StreamWriter = File.CreateText((Server.MapPath(directoryToSearch) + Path.DirectorySeparatorChar + txtNewFileName.Text))
				sw.Write((header.ToString() + editorMain.Html + footer.ToString()))
				sw.Close()
				InitFiles()
			Catch ex As Exception
				Response.Write(("An error occured while saving. Error details: " + ex.Message))
			End Try
			editorMain.Html = ""
			txtNewFileName.Text = ""
		End Sub	   'btnSave_Click

	End Class
End Namespace